"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CircularProgressInPage = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styles = require("@material-ui/core/styles");

var _CircularProgress = _interopRequireDefault(require("@material-ui/core/CircularProgress"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var styles = function styles() {
  return {
    worm: {
      position: 'absolute',
      zIndex: 2000,
      top: 250,
      left: '50%',
      marginTop: -50,
      marginLeft: -40
    }
  };
};

var propTypes = {
  classes: _propTypes["default"].objectOf(_propTypes["default"].any).isRequired,
  color: _propTypes["default"].string
};
var defaultProps = {
  color: undefined
};

var __CircularProgressInPage = function __CircularProgressInPage(_ref) {
  var color = _ref.color,
      classes = _ref.classes;
  return _react["default"].createElement(_CircularProgress["default"], {
    style: {
      color: color
    },
    size: 80,
    thickness: 7,
    className: classes.worm
  });
};

__CircularProgressInPage.propTypes = propTypes;
__CircularProgressInPage.defaultProps = defaultProps;
var CircularProgressInPage = (0, _styles.withStyles)(styles)(__CircularProgressInPage);
exports.CircularProgressInPage = CircularProgressInPage;